from ..io.dio_manager import DIO_Mgr
from ..modules.lib.reporter import Reporter
from ..modules.lib.report import Report


class DIReporter(Reporter):
    def __init__(self, start, dio_mgr, type_isPolling, port):
        super().__init__()
#        port = 1(DI1), port = 2 (DI2)
        self._port = port
        self._dio_mgr = dio_mgr
        self._type_isPolling = type_isPolling

        self._oneshot = False
        self._oneshot_send = False
        self._start = start

    def data_type(self):
        return "di"

    def oneshot_report(self):
        self._oneshot = True

    def set_config(self, type_isPolling):
        self._start = False
        self._type_isPolling = type_isPolling

    def start(self):
        self._start = True

    def create_polling_report(self):
        val = self._dio_mgr.get_DI(self._port)
        report = None

        if self._port is DIO_Mgr.DI1_PORT:
            report = Report.report_now(
                'measurement',
                    DI1_polling=val
            )
        elif self._port is DIO_Mgr.DI2_PORT:
            report = Report.report_now(
                'measurement',
                    DI2_polling=val
            )

        return report

    def create_edge_report(self):
        val = self._dio_mgr.get_DI_edge(self._port)
        report = None

        if self._port is DIO_Mgr.DI1_PORT:
            report = Report.report_now(
                'measurement',
                    DI1_edge=val
            )
        elif self._port is DIO_Mgr.DI2_PORT:
            report = Report.report_now(
                'measurement',
                    DI2_edge=val
            )

        return report

    def report(self):
        report = None

        if self._start is False:
            return (report, None)

        if self._oneshot is False or (self._oneshot is True and self._oneshot_send is False):
            if self._type_isPolling:
                report = self.create_polling_report()
            else:
                report = self.create_edge_report()
            self._oneshot_send = True

        return (report, None)

#
# End of File
#
